# Revision history for sayable

## 1.2.4.0 -- 2023-11-25

* Fix sayableSubConstraints filtering to only apply to outer constructor and
  still consider inner elements.
* Add Set, Seq, and NonEmpty to List in avoiding outer constructor dependencies
  for sayableSubConstraints.
* Fix sayableSubConstraints to consider all elements and not just top-level.


## 1.2.3.1 -- 2023-11-12

* Reduce maximum constraint tuple arity generated by `sayableSubConstraints` to
  60.

## 1.2.3.0 -- 2023-10-22

* Added `sayableSubConstraints` for specifying data sub-element `Sayable`
  constraints automatically via TemplateHaskell.

## 1.2.2.0 -- 2023-10-18

* Added `sez_` helper, which is the same as `sez` but it uses an unlimited output
  width to ensure the result is not wrapped (unless the output explicitly
  specifies newlines).

## 1.2.1.0 -- 2023-10-18

* Added default `Sayable` instances for `Float` and `Double`.

## 1.2.0.0 -- 2023-10-01

* Changed `&+*` and `&!+*` to `&:*` and `&!:*` to avoid confusion with normal `+`
  indication of concatenation.
* Added `&+*` which acts like `&*` but does not add a space separator relative to
  the preceding output.
* Added `&+?` operator to show an immediate adjacent `Just` value.
* Added various tests.

## 1.1.1.0 -- 2023-06-20

* Add Haddock documentation showing examples for operators.
* Support GHC 9.6

## 1.1.0.0 -- 2023-01-17

* Added `&<`, `&<*`, and `&<?` operators to generate a newline between expressing
  their second arguments.
* Added `&!?` for Prettyprinter-processed Maybe sayable.
* Added `&!$*` for Prettyprinter-processed list result sayable.
* Removed unneeded 'SayMessage' type with 'sayMsg' extractor.
* Change `&*` and `&!*` formatting to generate spaces or newlines as appropriate
  to the current output width.
* Miscellaneous documentation fixes and enhancements

## 1.0.2.0 -- 2022-12-23

* Specific GHC support range for GHC 8.8--9.4
* Small cabal file adjustments.

## 1.0.1.0 -- 2022-12-01

* Added Sayable instance for Char.

## 1.0.0.0 -- 2022-06-30

* First independent version.
